"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = FullscreenDialog;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _AppBar = _interopRequireDefault(require("material-ui/AppBar"));

var _IconButton = _interopRequireDefault(require("material-ui/IconButton"));

var _close = _interopRequireDefault(require("material-ui/svg-icons/navigation/close"));

var _FullscreenDialogFrame = _interopRequireDefault(require("./FullscreenDialogFrame"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var getStyles = function getStyles(props, theme) {
  var styles = {
    root: {
      display: 'flex',
      flexDirection: 'column'
    },
    appBar: {
      height: (props.appBarStyle ? props.appBarStyle.height : null) || theme.appBar.height
    },
    container: {
      flex: 1,
      overflow: 'auto'
    }
  };

  if (props.immersive) {
    styles.appBar.background = 'linear-gradient(0deg, rgba(0,0,0,0), rgba(0,0,0,0.4)';
    styles.appBar.position = 'absolute';
  }

  return styles;
};

function FullscreenDialog(props, _ref) {
  var muiTheme = _ref.muiTheme;
  var styles = getStyles(props, muiTheme);
  var actionButton = props.actionButton,
      appBarClassName = props.appBarClassName,
      appBarStyle = props.appBarStyle,
      appBarZDepth = props.appBarZDepth,
      children = props.children,
      closeIcon = props.closeIcon,
      containerClassName = props.containerClassName,
      containerStyle = props.containerStyle,
      immersive = props.immersive,
      onRequestClose = props.onRequestClose,
      open = props.open,
      style = props.style,
      title = props.title,
      titleStyle = props.titleStyle;
  return /*#__PURE__*/_react["default"].createElement(_FullscreenDialogFrame["default"], {
    open: open,
    style: _objectSpread(_objectSpread({}, style), styles.root)
  }, /*#__PURE__*/_react["default"].createElement(_AppBar["default"], {
    className: appBarClassName,
    title: title,
    titleStyle: titleStyle,
    style: _objectSpread(_objectSpread({}, styles.appBar), appBarStyle),
    iconElementLeft: /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
      onClick: onRequestClose
    }, closeIcon),
    iconElementRight: actionButton,
    showMenuIconButton: onRequestClose != null,
    zDepth: immersive ? 0 : appBarZDepth
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: containerClassName,
    style: _objectSpread(_objectSpread({}, styles.container), containerStyle)
  }, children));
}

FullscreenDialog.propTypes = {
  /**
   * A `FlatButton` or `IconButton` that is used as affirmative action button.
   */
  actionButton: _propTypes["default"].node,

  /**
   * Set the CSS classes of the app bar.
   */
  appBarClassName: _propTypes["default"].string,

  /**
   * Overrides the inline-styles of the app bar.
   */
  appBarStyle: _propTypes["default"].object,

  /**
   * Overrides the z-depth of the app bar, will affect its shadow. This is ignored if immersive is set to `true`.
   */
  appBarZDepth: _propTypes["default"].oneOf([0, 1, 2, 3, 4, 5]),

  /**
   * Children elements.
   */
  children: _propTypes["default"].node,

  /**
   * Icon element used for the dismissive action. This is hidden if `onRequestClose` is not set.
   */
  closeIcon: _propTypes["default"].node,

  /**
   * Set the CSS classes of the dialog's children container.
   */
  containerClassName: _propTypes["default"].string,

  /**
   * Overrides the inline-styles of the dialog's children container.
   */
  containerStyle: _propTypes["default"].object,

  /**
   *  Toggles the immersive mode. If set to `true`, the app bar has a semi-transparent gradient and overlays the content.
   */
  immersive: _propTypes["default"].bool,

  /**
   * Callback that is invoked when the dismissive action button is touched.
   */
  onRequestClose: _propTypes["default"].func,

  /**
   * Controls whether the dialog is opened or not.
   */
  open: _propTypes["default"].bool.isRequired,

  /**
   * Overrides the inline-styles of the dialog's root element.
   */
  style: _propTypes["default"].object,

  /**
   * The title of the dialog.
   */
  title: _propTypes["default"].string,

  /**
   * Overrides the inline-styles of the app bar's title element.
   */
  titleStyle: _propTypes["default"].object
};
FullscreenDialog.defaultProps = {
  appBarZDepth: 1,
  closeIcon: /*#__PURE__*/_react["default"].createElement(_close["default"], null),
  immersive: false
};
FullscreenDialog.contextTypes = {
  muiTheme: _propTypes["default"].object
};