"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = FullscreenDialog;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Dialog = _interopRequireDefault(require("@material-ui/core/Dialog"));

var _Transition = _interopRequireDefault(require("react-transition-group/Transition"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// disable the animation when using Safari's swipe-back gesture
// TODO make this configurable with a prop
var disableAnimationIfSwiping = true || !!process.env.IOS;
var disableNextAnimation = true;
document.addEventListener('click', function () {
  disableNextAnimation = false;
  setTimeout(function () {
    disableNextAnimation = true;
  }, 500);
});
var styles = {
  entering: {
    opacity: 1
  },
  entered: {
    opacity: 1
  }
};
var transitionStyles = {
  initial: {
    transition: 'all 225ms cubic-bezier(0.0, 0.0, 0.2, 1)',
    transform: 'translate(0, 56px)'
  },
  entering: {
    transform: 'translate(0, 0px)',
    transition: 'all 225ms cubic-bezier(0.0, 0.0, 0.2, 1)'
  },
  enteringFast: {
    transform: 'translate(0, 0px)',
    transition: 'none'
  },
  exiting: {
    transition: 'all 195ms cubic-bezier(0.4, 0.0, 1, 1)',
    transform: 'translate(0, 56px)'
  },
  exitingFast: {
    transition: 'none'
  },
  exited: {
    transition: 'all 225ms cubic-bezier(0.0, 0.0, 0.2, 1)',
    transform: 'translate(0, 56px)'
  }
};

function setStyles(newStyles, node) {
  for (var _i = 0, _Object$keys = Object.keys(newStyles); _i < _Object$keys.length; _i++) {
    var style = _Object$keys[_i];
    // eslint-disable-next-line no-param-reassign
    node.style[style] = newStyles[style];
  }
}

var Slide = /*#__PURE__*/function (_React$Component) {
  _inherits(Slide, _React$Component);

  var _super = _createSuper(Slide);

  function Slide() {
    var _this;

    _classCallCheck(this, Slide);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "handleEnter", function (node) {
      if (_this.props.onEnter) {
        _this.props.onEnter(node);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleEntering", function (node) {
      setStyles(disableAnimationIfSwiping && disableNextAnimation ? transitionStyles.enteringFast : transitionStyles.entering, node);
      disableNextAnimation = true;

      if (_this.props.onEntering) {
        _this.props.onEntering(node);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleExit", function (node) {
      setStyles(disableAnimationIfSwiping && disableNextAnimation ? transitionStyles.exitingFast : transitionStyles.exiting, node);
      disableNextAnimation = true;

      if (_this.props.onExit) {
        _this.props.onExit(node);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleExited", function (node) {
      setStyles(transitionStyles.exited, node);

      if (_this.props.onExited) {
        _this.props.onExited(node);
      }
    });

    return _this;
  }

  _createClass(Slide, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          inProp = _this$props["in"],
          onEnter = _this$props.onEnter,
          onEntering = _this$props.onEntering,
          onExit = _this$props.onExit,
          onExited = _this$props.onExited,
          styleProp = _this$props.style,
          onClose = _this$props.onClose,
          other = _objectWithoutProperties(_this$props, ["children", "in", "onEnter", "onEntering", "onExit", "onExited", "style", "onClose"]);

      var style = _objectSpread(_objectSpread({}, styleProp), /*#__PURE__*/_react["default"].isValidElement(children) ? children.props.style : {});

      var handleClose = function handleClose() {
        disableNextAnimation = false;
        onClose();
      };

      return /*#__PURE__*/_react["default"].createElement(_Transition["default"], _extends({
        appear: true,
        "in": inProp,
        onEntering: this.handleEntering,
        onEnter: this.handleEnter,
        onExit: this.handleExit,
        onExited: this.handleExited,
        timeout: {
          exit: 225,
          enter: 195,
          appear: 195
        },
        onClose: handleClose
      }, other), function (state, childProps) {
        return /*#__PURE__*/_react["default"].cloneElement(children, _objectSpread({
          style: _objectSpread(_objectSpread(_objectSpread(_objectSpread({
            opacity: 0,
            willChange: 'opacity'
          }, transitionStyles.initial), styles[state]), style), children.props.style)
        }, childProps));
      });
    }
  }]);

  return Slide;
}(_react["default"].Component);

Slide.propTypes = {
  children: _propTypes["default"].element.isRequired,
  "in": _propTypes["default"].bool,
  onEnter: _propTypes["default"].func,
  onEntering: _propTypes["default"].func,
  onExit: _propTypes["default"].func,
  onExited: _propTypes["default"].func,
  style: _propTypes["default"].object,
  onClose: _propTypes["default"].func.isRequired
};

function FullscreenDialog(_ref) {
  var children = _ref.children,
      other = _objectWithoutProperties(_ref, ["children"]);

  return /*#__PURE__*/_react["default"].createElement(_Dialog["default"], _extends({}, other, {
    fullScreen: true,
    TransitionComponent: Slide,
    hideBackdrop: true
  }), children);
}

FullscreenDialog.propTypes = {
  children: _propTypes["default"].node
};